summaryrefslogtreecommitdiff
blob: 3639a2ba612762266f8d660c18742537636d3fa2 (plain)
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
--- update-pciids.sh
+++ update-pciids.sh
@@ -1,30 +1,41 @@
 #!/bin/sh
 
+[ "$1" = "-q" ] && quiet="true" || quiet="false"
+
 set -e
 SRC="http://pciids.sourceforge.net/v2.2/pci.ids"
 DEST=pci.ids
 PCI_COMPRESSED_IDS=
 GREP=grep
 
+# if pci.ids is read-only (because the filesystem is read-only),
+# then just skip this whole process.
+if ! touch ${DEST} >/dev/null 2>&1 ; then
+	${quiet} || echo "${DEST} is read-only, exiting."
+	exit 0
+fi
+
 if [ -n "$PCI_COMPRESSED_IDS" ] ; then
 	DECOMP="cat"
 	SRC="$SRC.gz"
 	GREP=zgrep
-elif which bzip2 >/dev/null ; then
+elif which bzip2 >/dev/null 2>&1 ; then
 	DECOMP="bzip2 -d"
 	SRC="$SRC.bz2"
-elif which gzip >/dev/null ; then
+elif which gzip >/dev/null 2>&1 ; then
 	DECOMP="gzip -d"
 	SRC="$SRC.gz"
 else
 	DECOMP="cat"
 fi
 
-if which curl >/dev/null ; then
+if which curl >/dev/null 2>&1 ; then
 	DL="curl -o $DEST.new $SRC"
-elif which wget >/dev/null ; then
+    ${quiet} && DL="$DL -s -S"
+elif which wget >/dev/null 2>&1 ; then
 	DL="wget -O $DEST.new $SRC"
-elif which lynx >/dev/null ; then
+	${quiet} && DL="$DL -q"
+elif which lynx >/dev/null 2>&1 ; then
 	DL="eval lynx -source $SRC >$DEST.new"
 else
 	echo >&2 "update-pciids: cannot find curl, wget or lynx"
@@ -55,4 +66,10 @@
 mv $DEST.neww $DEST
 rm $DEST.new
 
-echo "Done."
+# Older versions did not compress the ids file, so let's make sure we
+# clean that up.
+if [ ${DEST%.gz} != ${DEST} ] ; then
+	rm -f ${DEST%.gz} ${DEST%.gz}.old
+fi
+
+${quiet} || echo "Done."